
#include <string>
#include <vector>
#include <iostream>
#include <sstream>

#include "gdal\ogrsf_frmts.h"


using namespace std;

int main(void)

{
	OGRRegisterAll();

	OGRDataSource       *poDS;

	char* fileName = "c:\TestPolygon.shp";

	cout<<"Filename: " <<fileName<<endl;

	poDS = OGRSFDriverRegistrar::Open( fileName , FALSE );
	
	
	if( poDS == NULL )
	{
		cout<<"Open failed.\n";
		exit( 1 );
	}

	cout<<"File Opened Successfully.\n";

	OGRLayer  *poLayer;


	int cnt = poDS->GetLayerCount();
	
	cout<<"Total layers in file: "<<cnt<<endl;

	if(cnt==0){
		LogHelper::Instance()->LogDebug("Looks like empty file");
		OGRDataSource::DestroyDataSource( poDS );

		//return 0;
	}

	poLayer = poDS->GetLayer(0);

	//poLayer = poDS->GetLayerByName( "point" );
	OGRFeature *poFeature;

	poLayer->ResetReading();



	while( (poFeature = poLayer->GetNextFeature()) != NULL )
	{
		OGRFeatureDefn *poFDefn = poLayer->GetLayerDefn();
		int iField;

		for( iField = 0; iField < poFDefn->GetFieldCount(); iField++ )
		{
			OGRFieldDefn *poFieldDefn = poFDefn->GetFieldDefn( iField );

			if( poFieldDefn->GetType() == OFTInteger )
				printf( "%d,", poFeature->GetFieldAsInteger( iField ) );
			else if( poFieldDefn->GetType() == OFTReal )
				printf( "%.3f,", poFeature->GetFieldAsDouble(iField) );
			else if( poFieldDefn->GetType() == OFTString )
				printf( "%s,", poFeature->GetFieldAsString(iField) );
			else
				printf( "%s,", poFeature->GetFieldAsString(iField) );
		}


		OGRGeometry *poGeometry;


		poGeometry = poFeature->GetGeometryRef();
		if( poGeometry != NULL 
			&& wkbFlatten(poGeometry->getGeometryType()) == wkbPoint )
		{
			OGRPoint *poPoint = (OGRPoint *) poGeometry;

			printf( "%.3f,%3.f\n", poPoint->getX(), poPoint->getY() );
		}
		else
		{
			printf( "no point geometry\n" );
		}       
		OGRFeature::DestroyFeature( poFeature );
	}

	OGRDataSource::DestroyDataSource( poDS );

}
